/* timer.c generated by valac 0.56.17, the Vala compiler
 * generated from timer.vala, do not modify */

/*
 * Copyright (c) 2011-2015 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Arun Mahapatra <pratikarun@gmail.com>
 *          Kamil Prusko <kamilprusko@gmail.com>
 */

#include <glib.h>
#include <float.h>
#include <math.h>
#include "gnome-pomodoro.h"
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>

#define POMODORO_TIME_TO_RESET_SCORE 3600.0
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	POMODORO_TIMER_0_PROPERTY,
	POMODORO_TIMER_STATE_PROPERTY,
	POMODORO_TIMER_STATE_DURATION_PROPERTY,
	POMODORO_TIMER_ELAPSED_PROPERTY,
	POMODORO_TIMER_REMAINING_PROPERTY,
	POMODORO_TIMER_OFFSET_PROPERTY,
	POMODORO_TIMER_IS_PAUSED_PROPERTY,
	POMODORO_TIMER_TIMESTAMP_PROPERTY,
	POMODORO_TIMER_SCORE_PROPERTY,
	POMODORO_TIMER_NUM_PROPERTIES
};
static GParamSpec* pomodoro_timer_properties[POMODORO_TIMER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block19Data Block19Data;
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
enum  {
	POMODORO_TIMER_UPDATE_SIGNAL,
	POMODORO_TIMER_STATE_ENTER_SIGNAL,
	POMODORO_TIMER_STATE_LEAVE_SIGNAL,
	POMODORO_TIMER_STATE_CHANGED_SIGNAL,
	POMODORO_TIMER_DESTROY_SIGNAL,
	POMODORO_TIMER_NUM_SIGNALS
};
static guint pomodoro_timer_signals[POMODORO_TIMER_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PomodoroTimerPrivate {
	gdouble _offset;
	gdouble _timestamp;
	gdouble _score;
	guint timeout_source;
	PomodoroTimerState* _state;
	gboolean _is_paused;
};

struct _Block19Data {
	int _ref_count_;
	PomodoroTimer* timer;
};

static gint PomodoroTimer_private_offset;
static gpointer pomodoro_timer_parent_class = NULL;
static PomodoroTimer* pomodoro_timer_instance;
static PomodoroTimer* pomodoro_timer_instance = NULL;

static Block19Data* block19_data_ref (Block19Data* _data19_);
static void block19_data_unref (void * _userdata_);
static void ___lambda5_ (Block19Data* _data19_);
static void ____lambda5__pomodoro_timer_destroy (PomodoroTimer* _sender,
                                          gpointer self);
static void pomodoro_timer_set_is_paused_full (PomodoroTimer* self,
                                        gboolean value,
                                        gdouble timestamp);
static void pomodoro_timer_set_state_full (PomodoroTimer* self,
                                    PomodoroTimerState* state,
                                    gdouble timestamp);
static void pomodoro_timer_update_offset (PomodoroTimer* self);
static gboolean pomodoro_timer_resolve_state (PomodoroTimer* self);
static void pomodoro_timer_update_timeout (PomodoroTimer* self);
static gboolean pomodoro_timer_on_timeout (PomodoroTimer* self);
static void pomodoro_timer_stop_timeout (PomodoroTimer* self);
static void pomodoro_timer_start_timeout (PomodoroTimer* self);
static gboolean _pomodoro_timer_on_timeout_gsource_func (gpointer self);
static void pomodoro_timer_update_elapsed (PomodoroTimer* self);
static void pomodoro_timer_on_state_duration_notify (PomodoroTimer* self);
static void pomodoro_timer_real_dispose (GObject* base);
static void pomodoro_timer_set_offset (PomodoroTimer* self,
                                gdouble value);
static void pomodoro_timer_real_update (PomodoroTimer* self,
                                 gdouble timestamp);
static void pomodoro_timer_real_state_enter (PomodoroTimer* self,
                                      PomodoroTimerState* state);
static void _pomodoro_timer_on_state_duration_notify_g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self);
static void pomodoro_timer_real_state_leave (PomodoroTimer* self,
                                      PomodoroTimerState* state);
static void pomodoro_timer_real_state_changed (PomodoroTimer* self,
                                        PomodoroTimerState* state,
                                        PomodoroTimerState* previous_state);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void pomodoro_timer_real_destroy (PomodoroTimer* self);
static GObject * pomodoro_timer_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static void pomodoro_timer_finalize (GObject * obj);
static GType pomodoro_timer_get_type_once (void);
static void _vala_pomodoro_timer_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_pomodoro_timer_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);

static inline gpointer
pomodoro_timer_get_instance_private (PomodoroTimer* self)
{
	return G_STRUCT_MEMBER_P (self, PomodoroTimer_private_offset);
}

static Block19Data*
block19_data_ref (Block19Data* _data19_)
{
#line 124 "../src/timer.vala"
	g_atomic_int_inc (&_data19_->_ref_count_);
#line 124 "../src/timer.vala"
	return _data19_;
#line 165 "timer.c"
}

static void
block19_data_unref (void * _userdata_)
{
	Block19Data* _data19_;
	_data19_ = (Block19Data*) _userdata_;
#line 124 "../src/timer.vala"
	if (g_atomic_int_dec_and_test (&_data19_->_ref_count_)) {
#line 124 "../src/timer.vala"
		_g_object_unref0 (_data19_->timer);
#line 124 "../src/timer.vala"
		g_slice_free (Block19Data, _data19_);
#line 179 "timer.c"
	}
}

static void
___lambda5_ (Block19Data* _data19_)
{
	PomodoroTimer* _tmp0_;
	PomodoroTimer* _tmp1_;
#line 129 "../src/timer.vala"
	_tmp0_ = pomodoro_timer_instance;
#line 129 "../src/timer.vala"
	_tmp1_ = _data19_->timer;
#line 129 "../src/timer.vala"
	if (_tmp0_ == _tmp1_) {
#line 130 "../src/timer.vala"
		_g_object_unref0 (pomodoro_timer_instance);
#line 130 "../src/timer.vala"
		pomodoro_timer_instance = NULL;
#line 198 "timer.c"
	}
}

static void
____lambda5__pomodoro_timer_destroy (PomodoroTimer* _sender,
                                     gpointer self)
{
#line 128 "../src/timer.vala"
	___lambda5_ (self);
#line 208 "timer.c"
}

PomodoroTimer*
pomodoro_timer_get_default (void)
{
	PomodoroTimer* _tmp0_;
	PomodoroTimer* _tmp4_;
	PomodoroTimer* result;
#line 124 "../src/timer.vala"
	_tmp0_ = pomodoro_timer_instance;
#line 124 "../src/timer.vala"
	if (_tmp0_ == NULL) {
#line 221 "timer.c"
		Block19Data* _data19_;
		PomodoroTimer* _tmp1_;
		PomodoroTimer* _tmp2_;
		PomodoroTimer* _tmp3_;
#line 124 "../src/timer.vala"
		_data19_ = g_slice_new0 (Block19Data);
#line 124 "../src/timer.vala"
		_data19_->_ref_count_ = 1;
#line 125 "../src/timer.vala"
		_tmp1_ = pomodoro_timer_new ();
#line 125 "../src/timer.vala"
		_data19_->timer = _tmp1_;
#line 126 "../src/timer.vala"
		_tmp2_ = _data19_->timer;
#line 126 "../src/timer.vala"
		pomodoro_timer_set_default (_tmp2_);
#line 128 "../src/timer.vala"
		_tmp3_ = _data19_->timer;
#line 128 "../src/timer.vala"
		g_signal_connect_data (_tmp3_, "destroy", (GCallback) ____lambda5__pomodoro_timer_destroy, block19_data_ref (_data19_), (GClosureNotify) block19_data_unref, G_CONNECT_AFTER);
#line 124 "../src/timer.vala"
		block19_data_unref (_data19_);
#line 124 "../src/timer.vala"
		_data19_ = NULL;
#line 246 "timer.c"
	}
#line 135 "../src/timer.vala"
	_tmp4_ = pomodoro_timer_instance;
#line 135 "../src/timer.vala"
	result = _tmp4_;
#line 135 "../src/timer.vala"
	return result;
#line 254 "timer.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 140 "../src/timer.vala"
	return self ? g_object_ref (self) : NULL;
#line 262 "timer.c"
}

void
pomodoro_timer_set_default (PomodoroTimer* self)
{
	PomodoroTimer* _tmp0_;
#line 138 "../src/timer.vala"
	g_return_if_fail (self != NULL);
#line 140 "../src/timer.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 140 "../src/timer.vala"
	_g_object_unref0 (pomodoro_timer_instance);
#line 140 "../src/timer.vala"
	pomodoro_timer_instance = _tmp0_;
#line 277 "timer.c"
}

/**
         * Check whether timer is ticking.
         */
gboolean
pomodoro_timer_is_running (PomodoroTimer* self)
{
	gboolean result;
#line 146 "../src/timer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 148 "../src/timer.vala"
	result = self->priv->timeout_source != ((guint) 0);
#line 148 "../src/timer.vala"
	return result;
#line 293 "timer.c"
}

void
pomodoro_timer_start (PomodoroTimer* self,
                      gdouble timestamp)
{
	PomodoroTimerState* _tmp0_;
	PomodoroTimerState* _tmp1_;
#line 151 "../src/timer.vala"
	g_return_if_fail (self != NULL);
#line 153 "../src/timer.vala"
	pomodoro_timer_resume (self, timestamp);
#line 155 "../src/timer.vala"
	_tmp0_ = pomodoro_timer_get_state (self);
#line 155 "../src/timer.vala"
	_tmp1_ = _tmp0_;
#line 155 "../src/timer.vala"
	if (POMODORO_IS_DISABLED_STATE (_tmp1_)) {
#line 312 "timer.c"
		PomodoroPomodoroState* _tmp2_;
		PomodoroPomodoroState* _tmp3_;
#line 156 "../src/timer.vala"
		_tmp2_ = pomodoro_pomodoro_state_new_with_timestamp (timestamp);
#line 156 "../src/timer.vala"
		_tmp3_ = _tmp2_;
#line 156 "../src/timer.vala"
		pomodoro_timer_set_state (self, (PomodoroTimerState*) _tmp3_);
#line 156 "../src/timer.vala"
		_g_object_unref0 (_tmp3_);
#line 323 "timer.c"
	}
}

void
pomodoro_timer_stop (PomodoroTimer* self,
                     gdouble timestamp)
{
	PomodoroTimerState* _tmp0_;
	PomodoroTimerState* _tmp1_;
#line 160 "../src/timer.vala"
	g_return_if_fail (self != NULL);
#line 162 "../src/timer.vala"
	pomodoro_timer_resume (self, timestamp);
#line 164 "../src/timer.vala"
	_tmp0_ = pomodoro_timer_get_state (self);
#line 164 "../src/timer.vala"
	_tmp1_ = _tmp0_;
#line 164 "../src/timer.vala"
	if (!POMODORO_IS_DISABLED_STATE (_tmp1_)) {
#line 343 "timer.c"
		PomodoroDisabledState* _tmp2_;
		PomodoroDisabledState* _tmp3_;
#line 165 "../src/timer.vala"
		_tmp2_ = pomodoro_disabled_state_new_with_timestamp (timestamp);
#line 165 "../src/timer.vala"
		_tmp3_ = _tmp2_;
#line 165 "../src/timer.vala"
		pomodoro_timer_set_state (self, (PomodoroTimerState*) _tmp3_);
#line 165 "../src/timer.vala"
		_g_object_unref0 (_tmp3_);
#line 354 "timer.c"
	}
}

void
pomodoro_timer_toggle (PomodoroTimer* self,
                       gdouble timestamp)
{
	PomodoroTimerState* _tmp0_;
	PomodoroTimerState* _tmp1_;
#line 169 "../src/timer.vala"
	g_return_if_fail (self != NULL);
#line 171 "../src/timer.vala"
	_tmp0_ = pomodoro_timer_get_state (self);
#line 171 "../src/timer.vala"
	_tmp1_ = _tmp0_;
#line 171 "../src/timer.vala"
	if (POMODORO_IS_DISABLED_STATE (_tmp1_)) {
#line 172 "../src/timer.vala"
		pomodoro_timer_start (self, timestamp);
#line 374 "timer.c"
	} else {
#line 175 "../src/timer.vala"
		pomodoro_timer_stop (self, timestamp);
#line 378 "timer.c"
	}
}

void
pomodoro_timer_pause (PomodoroTimer* self,
                      gdouble timestamp)
{
#line 179 "../src/timer.vala"
	g_return_if_fail (self != NULL);
#line 181 "../src/timer.vala"
	pomodoro_timer_set_is_paused_full (self, TRUE, timestamp);
#line 390 "timer.c"
}

void
pomodoro_timer_resume (PomodoroTimer* self,
                       gdouble timestamp)
{
#line 184 "../src/timer.vala"
	g_return_if_fail (self != NULL);
#line 186 "../src/timer.vala"
	pomodoro_timer_set_is_paused_full (self, FALSE, timestamp);
#line 401 "timer.c"
}

void
pomodoro_timer_reset (PomodoroTimer* self,
                      gdouble timestamp)
{
	PomodoroDisabledState* _tmp0_;
	PomodoroDisabledState* _tmp1_;
#line 189 "../src/timer.vala"
	g_return_if_fail (self != NULL);
#line 191 "../src/timer.vala"
	pomodoro_timer_resume (self, timestamp);
#line 193 "../src/timer.vala"
	pomodoro_timer_set_score (self, 0.0);
#line 194 "../src/timer.vala"
	_tmp0_ = pomodoro_disabled_state_new_with_timestamp (timestamp);
#line 194 "../src/timer.vala"
	_tmp1_ = _tmp0_;
#line 194 "../src/timer.vala"
	pomodoro_timer_set_state (self, (PomodoroTimerState*) _tmp1_);
#line 194 "../src/timer.vala"
	_g_object_unref0 (_tmp1_);
#line 424 "timer.c"
}

void
pomodoro_timer_skip (PomodoroTimer* self,
                     gdouble timestamp)
{
	PomodoroTimerState* _tmp0_;
	gdouble _tmp1_;
	PomodoroTimerState* _tmp2_;
	PomodoroTimerState* _tmp3_;
#line 197 "../src/timer.vala"
	g_return_if_fail (self != NULL);
#line 199 "../src/timer.vala"
	_tmp0_ = self->priv->_state;
#line 199 "../src/timer.vala"
	_tmp1_ = self->priv->_score;
#line 199 "../src/timer.vala"
	_tmp2_ = pomodoro_timer_state_create_next_state (_tmp0_, _tmp1_, timestamp);
#line 199 "../src/timer.vala"
	_tmp3_ = _tmp2_;
#line 199 "../src/timer.vala"
	pomodoro_timer_set_state (self, _tmp3_);
#line 199 "../src/timer.vala"
	_g_object_unref0 (_tmp3_);
#line 449 "timer.c"
}

/**
         * set_state_full
         *
         * Changes the state and sets new timestamp
         */
static void
pomodoro_timer_set_state_full (PomodoroTimer* self,
                               PomodoroTimerState* state,
                               gdouble timestamp)
{
	PomodoroTimerState* previous_state = NULL;
	PomodoroTimerState* _tmp0_;
	PomodoroTimerState* _tmp1_;
	PomodoroTimerState* _tmp2_;
	PomodoroTimerState* _tmp3_;
	PomodoroTimerState* _tmp4_;
#line 207 "../src/timer.vala"
	g_return_if_fail (self != NULL);
#line 207 "../src/timer.vala"
	g_return_if_fail (state != NULL);
#line 210 "../src/timer.vala"
	_tmp0_ = self->priv->_state;
#line 210 "../src/timer.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 210 "../src/timer.vala"
	previous_state = _tmp1_;
#line 212 "../src/timer.vala"
	pomodoro_timer_set_timestamp (self, timestamp);
#line 214 "../src/timer.vala"
	_tmp2_ = self->priv->_state;
#line 214 "../src/timer.vala"
	g_signal_emit (self, pomodoro_timer_signals[POMODORO_TIMER_STATE_LEAVE_SIGNAL], 0, _tmp2_);
#line 216 "../src/timer.vala"
	_tmp3_ = _g_object_ref0 (state);
#line 216 "../src/timer.vala"
	_g_object_unref0 (self->priv->_state);
#line 216 "../src/timer.vala"
	self->priv->_state = _tmp3_;
#line 217 "../src/timer.vala"
	pomodoro_timer_update_offset (self);
#line 219 "../src/timer.vala"
	_tmp4_ = self->priv->_state;
#line 219 "../src/timer.vala"
	g_signal_emit (self, pomodoro_timer_signals[POMODORO_TIMER_STATE_ENTER_SIGNAL], 0, _tmp4_);
#line 221 "../src/timer.vala"
	if (!pomodoro_timer_resolve_state (self)) {
#line 498 "timer.c"
		PomodoroTimerState* _tmp5_;
		PomodoroTimerState* _tmp6_;
#line 222 "../src/timer.vala"
		_tmp5_ = self->priv->_state;
#line 222 "../src/timer.vala"
		_tmp6_ = previous_state;
#line 222 "../src/timer.vala"
		g_signal_emit (self, pomodoro_timer_signals[POMODORO_TIMER_STATE_CHANGED_SIGNAL], 0, _tmp5_, _tmp6_);
#line 507 "timer.c"
	}
#line 207 "../src/timer.vala"
	_g_object_unref0 (previous_state);
#line 511 "timer.c"
}

static void
pomodoro_timer_set_is_paused_full (PomodoroTimer* self,
                                   gboolean value,
                                   gdouble timestamp)
{
	gboolean _tmp0_ = FALSE;
#line 226 "../src/timer.vala"
	g_return_if_fail (self != NULL);
#line 229 "../src/timer.vala"
	if (value) {
#line 229 "../src/timer.vala"
		_tmp0_ = self->priv->timeout_source == ((guint) 0);
#line 526 "timer.c"
	} else {
#line 229 "../src/timer.vala"
		_tmp0_ = FALSE;
#line 530 "timer.c"
	}
#line 229 "../src/timer.vala"
	if (_tmp0_) {
#line 230 "../src/timer.vala"
		return;
#line 536 "timer.c"
	}
#line 233 "../src/timer.vala"
	if (value != self->priv->_is_paused) {
#line 234 "../src/timer.vala"
		self->priv->_is_paused = value;
#line 236 "../src/timer.vala"
		pomodoro_timer_set_timestamp (self, timestamp);
#line 237 "../src/timer.vala"
		pomodoro_timer_update_offset (self);
#line 239 "../src/timer.vala"
		pomodoro_timer_update_timeout (self);
#line 241 "../src/timer.vala"
		g_object_notify ((GObject*) self, "is-paused");
#line 550 "timer.c"
	}
}

static gboolean
pomodoro_timer_on_timeout (PomodoroTimer* self)
{
	gboolean result;
#line 245 "../src/timer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 247 "../src/timer.vala"
	g_signal_emit (self, pomodoro_timer_signals[POMODORO_TIMER_UPDATE_SIGNAL], 0, pomodoro_get_current_time ());
#line 249 "../src/timer.vala"
	result = TRUE;
#line 249 "../src/timer.vala"
	return result;
#line 566 "timer.c"
}

static void
pomodoro_timer_stop_timeout (PomodoroTimer* self)
{
#line 252 "../src/timer.vala"
	g_return_if_fail (self != NULL);
#line 254 "../src/timer.vala"
	if (self->priv->timeout_source != ((guint) 0)) {
#line 255 "../src/timer.vala"
		g_source_remove (self->priv->timeout_source);
#line 256 "../src/timer.vala"
		self->priv->timeout_source = (guint) 0;
#line 580 "timer.c"
	}
}

static gboolean
_pomodoro_timer_on_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = pomodoro_timer_on_timeout ((PomodoroTimer*) self);
#line 263 "../src/timer.vala"
	return result;
#line 591 "timer.c"
}

static void
pomodoro_timer_start_timeout (PomodoroTimer* self)
{
#line 260 "../src/timer.vala"
	g_return_if_fail (self != NULL);
#line 262 "../src/timer.vala"
	if (self->priv->timeout_source == ((guint) 0)) {
#line 263 "../src/timer.vala"
		self->priv->timeout_source = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1000, _pomodoro_timer_on_timeout_gsource_func, g_object_ref (self), g_object_unref);
#line 603 "timer.c"
	}
}

static void
pomodoro_timer_update_timeout (PomodoroTimer* self)
{
	gboolean _tmp0_ = FALSE;
	PomodoroTimerState* _tmp1_;
	PomodoroTimerState* _tmp2_;
#line 267 "../src/timer.vala"
	g_return_if_fail (self != NULL);
#line 269 "../src/timer.vala"
	_tmp1_ = pomodoro_timer_get_state (self);
#line 269 "../src/timer.vala"
	_tmp2_ = _tmp1_;
#line 269 "../src/timer.vala"
	if (POMODORO_IS_DISABLED_STATE (_tmp2_)) {
#line 269 "../src/timer.vala"
		_tmp0_ = TRUE;
#line 623 "timer.c"
	} else {
#line 269 "../src/timer.vala"
		_tmp0_ = self->priv->_is_paused;
#line 627 "timer.c"
	}
#line 269 "../src/timer.vala"
	if (_tmp0_) {
#line 270 "../src/timer.vala"
		pomodoro_timer_stop_timeout (self);
#line 633 "timer.c"
	} else {
#line 273 "../src/timer.vala"
		pomodoro_timer_start_timeout (self);
#line 637 "timer.c"
	}
}

static void
pomodoro_timer_update_offset (PomodoroTimer* self)
{
	gdouble _tmp0_;
	PomodoroTimerState* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	PomodoroTimerState* _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
#line 277 "../src/timer.vala"
	g_return_if_fail (self != NULL);
#line 279 "../src/timer.vala"
	_tmp0_ = self->priv->_timestamp;
#line 279 "../src/timer.vala"
	_tmp1_ = self->priv->_state;
#line 279 "../src/timer.vala"
	_tmp2_ = pomodoro_timer_state_get_timestamp (_tmp1_);
#line 279 "../src/timer.vala"
	_tmp3_ = _tmp2_;
#line 279 "../src/timer.vala"
	_tmp4_ = self->priv->_state;
#line 279 "../src/timer.vala"
	_tmp5_ = pomodoro_timer_state_get_elapsed (_tmp4_);
#line 279 "../src/timer.vala"
	_tmp6_ = _tmp5_;
#line 279 "../src/timer.vala"
	self->priv->_offset = (_tmp0_ - _tmp3_) - _tmp6_;
#line 669 "timer.c"
}

static void
pomodoro_timer_update_elapsed (PomodoroTimer* self)
{
	PomodoroTimerState* _tmp0_;
	gdouble _tmp1_;
	PomodoroTimerState* _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
#line 282 "../src/timer.vala"
	g_return_if_fail (self != NULL);
#line 284 "../src/timer.vala"
	_tmp0_ = self->priv->_state;
#line 284 "../src/timer.vala"
	_tmp1_ = self->priv->_timestamp;
#line 284 "../src/timer.vala"
	_tmp2_ = self->priv->_state;
#line 284 "../src/timer.vala"
	_tmp3_ = pomodoro_timer_state_get_timestamp (_tmp2_);
#line 284 "../src/timer.vala"
	_tmp4_ = _tmp3_;
#line 284 "../src/timer.vala"
	pomodoro_timer_state_set_elapsed (_tmp0_, (_tmp1_ - _tmp4_) - self->priv->_offset);
#line 694 "timer.c"
}

/**
         * Resolve next states after timer elapse or state change.
         *
         * Return true if state has been changed.
         */
static gboolean
pomodoro_timer_resolve_state (PomodoroTimer* self)
{
	PomodoroTimerState* original_state = NULL;
	PomodoroTimerState* _tmp0_;
	PomodoroTimerState* _tmp1_;
	gboolean state_changed = FALSE;
	gboolean result;
#line 292 "../src/timer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 294 "../src/timer.vala"
	_tmp0_ = self->priv->_state;
#line 294 "../src/timer.vala"
	_tmp1_ = _g_object_ref0 (POMODORO_IS_TIMER_STATE (_tmp0_) ? ((PomodoroTimerState*) _tmp0_) : NULL);
#line 294 "../src/timer.vala"
	original_state = _tmp1_;
#line 295 "../src/timer.vala"
	state_changed = FALSE;
#line 297 "../src/timer.vala"
	while (TRUE) {
#line 722 "timer.c"
		gboolean _tmp2_ = FALSE;
		PomodoroTimerState* _tmp3_;
		gdouble _tmp4_;
		gdouble _tmp5_;
		PomodoroTimerState* _tmp7_;
		PomodoroTimerState* _tmp8_;
		gdouble _tmp9_;
		gdouble _tmp10_;
		PomodoroTimerState* _tmp11_;
		PomodoroTimerState* _tmp12_;
#line 297 "../src/timer.vala"
		_tmp3_ = self->priv->_state;
#line 297 "../src/timer.vala"
		_tmp4_ = pomodoro_timer_state_get_duration (_tmp3_);
#line 297 "../src/timer.vala"
		_tmp5_ = _tmp4_;
#line 297 "../src/timer.vala"
		if (_tmp5_ > 0.0) {
#line 741 "timer.c"
			PomodoroTimerState* _tmp6_;
#line 298 "../src/timer.vala"
			_tmp6_ = self->priv->_state;
#line 298 "../src/timer.vala"
			_tmp2_ = pomodoro_timer_state_is_completed (_tmp6_);
#line 747 "timer.c"
		} else {
#line 297 "../src/timer.vala"
			_tmp2_ = FALSE;
#line 751 "timer.c"
		}
#line 297 "../src/timer.vala"
		if (!_tmp2_) {
#line 297 "../src/timer.vala"
			break;
#line 757 "timer.c"
		}
#line 300 "../src/timer.vala"
		_tmp7_ = self->priv->_state;
#line 300 "../src/timer.vala"
		g_signal_emit (self, pomodoro_timer_signals[POMODORO_TIMER_STATE_LEAVE_SIGNAL], 0, _tmp7_);
#line 302 "../src/timer.vala"
		_tmp8_ = self->priv->_state;
#line 302 "../src/timer.vala"
		_tmp9_ = self->priv->_score;
#line 302 "../src/timer.vala"
		_tmp10_ = self->priv->_timestamp;
#line 302 "../src/timer.vala"
		_tmp11_ = pomodoro_timer_state_create_next_state (_tmp8_, _tmp9_, _tmp10_);
#line 302 "../src/timer.vala"
		_g_object_unref0 (self->priv->_state);
#line 302 "../src/timer.vala"
		self->priv->_state = _tmp11_;
#line 303 "../src/timer.vala"
		pomodoro_timer_update_offset (self);
#line 305 "../src/timer.vala"
		state_changed = TRUE;
#line 307 "../src/timer.vala"
		_tmp12_ = self->priv->_state;
#line 307 "../src/timer.vala"
		g_signal_emit (self, pomodoro_timer_signals[POMODORO_TIMER_STATE_ENTER_SIGNAL], 0, _tmp12_);
#line 783 "timer.c"
	}
#line 310 "../src/timer.vala"
	if (state_changed) {
#line 787 "timer.c"
		PomodoroTimerState* _tmp13_;
		PomodoroTimerState* _tmp14_;
#line 311 "../src/timer.vala"
		_tmp13_ = self->priv->_state;
#line 311 "../src/timer.vala"
		_tmp14_ = original_state;
#line 311 "../src/timer.vala"
		g_signal_emit (self, pomodoro_timer_signals[POMODORO_TIMER_STATE_CHANGED_SIGNAL], 0, _tmp13_, _tmp14_);
#line 796 "timer.c"
	}
#line 314 "../src/timer.vala"
	result = state_changed;
#line 314 "../src/timer.vala"
	_g_object_unref0 (original_state);
#line 314 "../src/timer.vala"
	return result;
#line 804 "timer.c"
}

static void
pomodoro_timer_on_state_duration_notify (PomodoroTimer* self)
{
	gdouble _tmp0_;
#line 356 "../src/timer.vala"
	g_return_if_fail (self != NULL);
#line 358 "../src/timer.vala"
	_tmp0_ = self->priv->_timestamp;
#line 358 "../src/timer.vala"
	g_signal_emit (self, pomodoro_timer_signals[POMODORO_TIMER_UPDATE_SIGNAL], 0, _tmp0_);
#line 360 "../src/timer.vala"
	g_object_notify ((GObject*) self, "state-duration");
#line 819 "timer.c"
}

GActionGroup*
pomodoro_timer_get_action_group (PomodoroTimer* self)
{
	GActionGroup* _tmp0_;
	GActionGroup* result;
#line 363 "../src/timer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 365 "../src/timer.vala"
	_tmp0_ = pomodoro_timer_action_group_for_timer (self);
#line 365 "../src/timer.vala"
	result = _tmp0_;
#line 365 "../src/timer.vala"
	return result;
#line 835 "timer.c"
}

/**
         * Saves timer state to settings.
         */
static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 3410 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 3411 "glib-2.0.vapi"
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
#line 3411 "glib-2.0.vapi"
	result = _tmp0_;
#line 3411 "glib-2.0.vapi"
	return result;
#line 854 "timer.c"
}

void
pomodoro_timer_save (PomodoroTimer* self,
                     GSettings* settings)
{
	GSettingsSchema* _tmp0_;
	GSettingsSchema* _tmp1_;
	GSettingsSchema* _tmp2_;
	const gchar* _tmp3_;
	GDateTime* timer_datetime = NULL;
	gdouble _tmp4_;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	GDateTime* state_datetime = NULL;
	PomodoroTimerState* _tmp7_;
	PomodoroTimerState* _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	GDateTime* _tmp11_;
	PomodoroTimerState* _tmp12_;
	PomodoroTimerState* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	PomodoroTimerState* _tmp16_;
	PomodoroTimerState* _tmp17_;
	gdouble _tmp18_;
	gdouble _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	PomodoroTimerState* _tmp22_;
	PomodoroTimerState* _tmp23_;
	gdouble _tmp24_;
	gdouble _tmp25_;
	gdouble _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gboolean _tmp29_;
	gboolean _tmp30_;
#line 371 "../src/timer.vala"
	g_return_if_fail (self != NULL);
#line 371 "../src/timer.vala"
	g_return_if_fail (settings != NULL);
#line 371 "../src/timer.vala"
	g_object_get (settings, "settings-schema", &_tmp0_, NULL);
#line 371 "../src/timer.vala"
	_tmp1_ = _tmp0_;
#line 371 "../src/timer.vala"
	_tmp2_ = _tmp1_;
#line 371 "../src/timer.vala"
	_tmp3_ = g_settings_schema_get_id (_tmp2_);
#line 371 "../src/timer.vala"
	_vala_return_if_fail (g_strcmp0 (_tmp3_, "org.gnome.pomodoro.state") == 0, "settings.settings_schema.get_id () == \"org.gnome.pomodoro.state\"");
#line 374 "../src/timer.vala"
	_tmp4_ = self->priv->_timestamp;
#line 374 "../src/timer.vala"
	_tmp5_ = g_date_time_new_from_unix_utc ((gint64) floor (_tmp4_));
#line 374 "../src/timer.vala"
	_tmp6_ = _tmp5_;
#line 374 "../src/timer.vala"
	_g_settings_schema_unref0 (_tmp2_);
#line 374 "../src/timer.vala"
	timer_datetime = _tmp6_;
#line 377 "../src/timer.vala"
	_tmp7_ = pomodoro_timer_get_state (self);
#line 377 "../src/timer.vala"
	_tmp8_ = _tmp7_;
#line 377 "../src/timer.vala"
	_tmp9_ = pomodoro_timer_state_get_timestamp (_tmp8_);
#line 377 "../src/timer.vala"
	_tmp10_ = _tmp9_;
#line 377 "../src/timer.vala"
	_tmp11_ = g_date_time_new_from_unix_utc ((gint64) floor (_tmp10_));
#line 377 "../src/timer.vala"
	state_datetime = _tmp11_;
#line 380 "../src/timer.vala"
	_tmp12_ = pomodoro_timer_get_state (self);
#line 380 "../src/timer.vala"
	_tmp13_ = _tmp12_;
#line 380 "../src/timer.vala"
	_tmp14_ = pomodoro_timer_state_get_name (_tmp13_);
#line 380 "../src/timer.vala"
	_tmp15_ = _tmp14_;
#line 380 "../src/timer.vala"
	g_settings_set_string (settings, "timer-state", _tmp15_);
#line 382 "../src/timer.vala"
	_tmp16_ = pomodoro_timer_get_state (self);
#line 382 "../src/timer.vala"
	_tmp17_ = _tmp16_;
#line 382 "../src/timer.vala"
	_tmp18_ = pomodoro_timer_state_get_duration (_tmp17_);
#line 382 "../src/timer.vala"
	_tmp19_ = _tmp18_;
#line 382 "../src/timer.vala"
	g_settings_set_double (settings, "timer-state-duration", _tmp19_);
#line 384 "../src/timer.vala"
	_tmp20_ = g_date_time_to_string (state_datetime);
#line 384 "../src/timer.vala"
	_tmp21_ = _tmp20_;
#line 384 "../src/timer.vala"
	g_settings_set_string (settings, "timer-state-date", _tmp21_);
#line 384 "../src/timer.vala"
	_g_free0 (_tmp21_);
#line 386 "../src/timer.vala"
	_tmp22_ = pomodoro_timer_get_state (self);
#line 386 "../src/timer.vala"
	_tmp23_ = _tmp22_;
#line 386 "../src/timer.vala"
	_tmp24_ = pomodoro_timer_state_get_elapsed (_tmp23_);
#line 386 "../src/timer.vala"
	_tmp25_ = _tmp24_;
#line 386 "../src/timer.vala"
	g_settings_set_double (settings, "timer-elapsed", _tmp25_);
#line 388 "../src/timer.vala"
	_tmp26_ = self->priv->_score;
#line 388 "../src/timer.vala"
	g_settings_set_double (settings, "timer-score", _tmp26_);
#line 390 "../src/timer.vala"
	_tmp27_ = g_date_time_to_string (timer_datetime);
#line 390 "../src/timer.vala"
	_tmp28_ = _tmp27_;
#line 390 "../src/timer.vala"
	g_settings_set_string (settings, "timer-date", _tmp28_);
#line 390 "../src/timer.vala"
	_g_free0 (_tmp28_);
#line 392 "../src/timer.vala"
	_tmp29_ = pomodoro_timer_get_is_paused (self);
#line 392 "../src/timer.vala"
	_tmp30_ = _tmp29_;
#line 392 "../src/timer.vala"
	g_settings_set_boolean (settings, "timer-paused", _tmp30_);
#line 371 "../src/timer.vala"
	_g_date_time_unref0 (state_datetime);
#line 371 "../src/timer.vala"
	_g_date_time_unref0 (timer_datetime);
#line 990 "timer.c"
}

/**
         * Restores timer state from settings.
         *
         * When restoring, lost time is considered as interruption.
         * If exceeded time of a long break, timer would reset.
         */
void
pomodoro_timer_restore (PomodoroTimer* self,
                        GSettings* settings,
                        gdouble timestamp)
{
	GSettingsSchema* _tmp0_;
	GSettingsSchema* _tmp1_;
	GSettingsSchema* _tmp2_;
	const gchar* _tmp3_;
	PomodoroTimerState* state = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_;
	PomodoroTimerState* _tmp6_;
	PomodoroTimerState* _tmp7_;
	gboolean is_paused = FALSE;
	gdouble score = 0.0;
	gdouble last_timestamp = 0.0;
	PomodoroTimerState* _tmp8_;
	gboolean _tmp29_ = FALSE;
	PomodoroTimerState* _tmp30_;
#line 402 "../src/timer.vala"
	g_return_if_fail (self != NULL);
#line 402 "../src/timer.vala"
	g_return_if_fail (settings != NULL);
#line 402 "../src/timer.vala"
	g_object_get (settings, "settings-schema", &_tmp0_, NULL);
#line 402 "../src/timer.vala"
	_tmp1_ = _tmp0_;
#line 402 "../src/timer.vala"
	_tmp2_ = _tmp1_;
#line 402 "../src/timer.vala"
	_tmp3_ = g_settings_schema_get_id (_tmp2_);
#line 402 "../src/timer.vala"
	_vala_return_if_fail (g_strcmp0 (_tmp3_, "org.gnome.pomodoro.state") == 0, "settings.settings_schema.get_id () == \"org.gnome.pomodoro.state\"");
#line 406 "../src/timer.vala"
	_tmp4_ = g_settings_get_string (settings, "timer-state");
#line 406 "../src/timer.vala"
	_tmp5_ = _tmp4_;
#line 406 "../src/timer.vala"
	_tmp6_ = pomodoro_timer_state_lookup (_tmp5_);
#line 406 "../src/timer.vala"
	_tmp7_ = _tmp6_;
#line 406 "../src/timer.vala"
	_g_free0 (_tmp5_);
#line 406 "../src/timer.vala"
	_g_settings_schema_unref0 (_tmp2_);
#line 406 "../src/timer.vala"
	state = _tmp7_;
#line 407 "../src/timer.vala"
	is_paused = g_settings_get_boolean (settings, "timer-paused");
#line 408 "../src/timer.vala"
	score = g_settings_get_double (settings, "timer-score");
#line 409 "../src/timer.vala"
	last_timestamp = 0.0;
#line 411 "../src/timer.vala"
	_tmp8_ = state;
#line 411 "../src/timer.vala"
	if (_tmp8_ != NULL) {
#line 1057 "timer.c"
		PomodoroTimerState* _tmp9_;
		PomodoroTimerState* _tmp10_;
		GDateTime* state_datetime = NULL;
		gchar* _tmp11_;
		gchar* _tmp12_;
		GTimeZone* _tmp13_;
		GTimeZone* _tmp14_;
		GDateTime* _tmp15_;
		GDateTime* _tmp16_;
		GDateTime* last_datetime = NULL;
		gchar* _tmp17_;
		gchar* _tmp18_;
		GTimeZone* _tmp19_;
		GTimeZone* _tmp20_;
		GDateTime* _tmp21_;
		GDateTime* _tmp22_;
		gboolean _tmp23_ = FALSE;
		GDateTime* _tmp24_;
#line 413 "../src/timer.vala"
		_tmp9_ = state;
#line 413 "../src/timer.vala"
		pomodoro_timer_state_set_duration (_tmp9_, g_settings_get_double (settings, "timer-state-duration"));
#line 414 "../src/timer.vala"
		_tmp10_ = state;
#line 414 "../src/timer.vala"
		pomodoro_timer_state_set_elapsed (_tmp10_, g_settings_get_double (settings, "timer-elapsed"));
#line 416 "../src/timer.vala"
		_tmp11_ = g_settings_get_string (settings, "timer-state-date");
#line 416 "../src/timer.vala"
		_tmp12_ = _tmp11_;
#line 416 "../src/timer.vala"
		_tmp13_ = g_time_zone_new_local ();
#line 416 "../src/timer.vala"
		_tmp14_ = _tmp13_;
#line 416 "../src/timer.vala"
		_tmp15_ = g_date_time_new_from_iso8601 (_tmp12_, _tmp14_);
#line 416 "../src/timer.vala"
		_tmp16_ = _tmp15_;
#line 416 "../src/timer.vala"
		_g_time_zone_unref0 (_tmp14_);
#line 416 "../src/timer.vala"
		_g_free0 (_tmp12_);
#line 416 "../src/timer.vala"
		state_datetime = _tmp16_;
#line 419 "../src/timer.vala"
		_tmp17_ = g_settings_get_string (settings, "timer-date");
#line 419 "../src/timer.vala"
		_tmp18_ = _tmp17_;
#line 419 "../src/timer.vala"
		_tmp19_ = g_time_zone_new_local ();
#line 419 "../src/timer.vala"
		_tmp20_ = _tmp19_;
#line 419 "../src/timer.vala"
		_tmp21_ = g_date_time_new_from_iso8601 (_tmp18_, _tmp20_);
#line 419 "../src/timer.vala"
		_tmp22_ = _tmp21_;
#line 419 "../src/timer.vala"
		_g_time_zone_unref0 (_tmp20_);
#line 419 "../src/timer.vala"
		_g_free0 (_tmp18_);
#line 419 "../src/timer.vala"
		last_datetime = _tmp22_;
#line 422 "../src/timer.vala"
		_tmp24_ = state_datetime;
#line 422 "../src/timer.vala"
		if (_tmp24_ != NULL) {
#line 1124 "timer.c"
			GDateTime* _tmp25_;
#line 422 "../src/timer.vala"
			_tmp25_ = last_datetime;
#line 422 "../src/timer.vala"
			_tmp23_ = _tmp25_ != NULL;
#line 1130 "timer.c"
		} else {
#line 422 "../src/timer.vala"
			_tmp23_ = FALSE;
#line 1134 "timer.c"
		}
#line 422 "../src/timer.vala"
		if (_tmp23_) {
#line 1138 "timer.c"
			PomodoroTimerState* _tmp26_;
			GDateTime* _tmp27_;
			GDateTime* _tmp28_;
#line 423 "../src/timer.vala"
			_tmp26_ = state;
#line 423 "../src/timer.vala"
			_tmp27_ = state_datetime;
#line 423 "../src/timer.vala"
			pomodoro_timer_state_set_timestamp (_tmp26_, (gdouble) g_date_time_to_unix (_tmp27_));
#line 424 "../src/timer.vala"
			_tmp28_ = last_datetime;
#line 424 "../src/timer.vala"
			last_timestamp = (gdouble) g_date_time_to_unix (_tmp28_);
#line 1152 "timer.c"
		} else {
#line 430 "../src/timer.vala"
			_g_object_unref0 (state);
#line 430 "../src/timer.vala"
			state = NULL;
#line 1158 "timer.c"
		}
#line 411 "../src/timer.vala"
		_g_date_time_unref0 (last_datetime);
#line 411 "../src/timer.vala"
		_g_date_time_unref0 (state_datetime);
#line 1164 "timer.c"
	}
#line 434 "../src/timer.vala"
	_tmp30_ = state;
#line 434 "../src/timer.vala"
	if (_tmp30_ != NULL) {
#line 434 "../src/timer.vala"
		_tmp29_ = (timestamp - last_timestamp) < POMODORO_TIME_TO_RESET_SCORE;
#line 1172 "timer.c"
	} else {
#line 434 "../src/timer.vala"
		_tmp29_ = FALSE;
#line 1176 "timer.c"
	}
#line 434 "../src/timer.vala"
	if (_tmp29_) {
#line 1180 "timer.c"
		PomodoroTimerState* _tmp31_;
#line 436 "../src/timer.vala"
		g_object_freeze_notify ((GObject*) self);
#line 437 "../src/timer.vala"
		pomodoro_timer_set_score (self, score);
#line 438 "../src/timer.vala"
		_tmp31_ = state;
#line 438 "../src/timer.vala"
		pomodoro_timer_set_state_full (self, _tmp31_, last_timestamp);
#line 439 "../src/timer.vala"
		pomodoro_timer_pause (self, last_timestamp);
#line 440 "../src/timer.vala"
		g_object_thaw_notify ((GObject*) self);
#line 442 "../src/timer.vala"
		g_signal_emit (self, pomodoro_timer_signals[POMODORO_TIMER_UPDATE_SIGNAL], 0, timestamp);
#line 444 "../src/timer.vala"
		if (is_paused) {
#line 445 "../src/timer.vala"
			g_object_notify ((GObject*) self, "is-paused");
#line 1200 "timer.c"
		} else {
#line 448 "../src/timer.vala"
			pomodoro_timer_resume (self, timestamp);
#line 1204 "timer.c"
		}
	} else {
#line 452 "../src/timer.vala"
		pomodoro_timer_reset (self, timestamp);
#line 1209 "timer.c"
	}
#line 402 "../src/timer.vala"
	_g_object_unref0 (state);
#line 1213 "timer.c"
}

static void
pomodoro_timer_real_dispose (GObject* base)
{
	PomodoroTimer * self;
#line 461 "../src/timer.vala"
	self = (PomodoroTimer*) base;
#line 463 "../src/timer.vala"
	if (self->priv->timeout_source != ((guint) 0)) {
#line 464 "../src/timer.vala"
		g_source_remove (self->priv->timeout_source);
#line 465 "../src/timer.vala"
		self->priv->timeout_source = (guint) 0;
#line 1228 "timer.c"
	}
#line 468 "../src/timer.vala"
	G_OBJECT_CLASS (pomodoro_timer_parent_class)->dispose (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject));
#line 1232 "timer.c"
}

PomodoroTimer*
pomodoro_timer_construct (GType object_type)
{
	PomodoroTimer * self = NULL;
#line 34 "../src/timer.vala"
	self = (PomodoroTimer*) g_object_new (object_type, NULL);
#line 34 "../src/timer.vala"
	return self;
#line 1243 "timer.c"
}

PomodoroTimer*
pomodoro_timer_new (void)
{
#line 34 "../src/timer.vala"
	return pomodoro_timer_construct (POMODORO_TYPE_TIMER);
#line 1251 "timer.c"
}

PomodoroTimerState*
pomodoro_timer_get_state (PomodoroTimer* self)
{
	PomodoroTimerState* result;
	PomodoroTimerState* _tmp0_;
#line 39 "../src/timer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "../src/timer.vala"
	_tmp0_ = self->priv->_state;
#line 40 "../src/timer.vala"
	result = _tmp0_;
#line 40 "../src/timer.vala"
	return result;
#line 1267 "timer.c"
}

void
pomodoro_timer_set_state (PomodoroTimer* self,
                          PomodoroTimerState* value)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
#line 42 "../src/timer.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/timer.vala"
	_tmp0_ = pomodoro_timer_state_get_timestamp (value);
#line 43 "../src/timer.vala"
	_tmp1_ = _tmp0_;
#line 43 "../src/timer.vala"
	pomodoro_timer_set_state_full (self, value, _tmp1_);
#line 42 "../src/timer.vala"
	g_object_notify_by_pspec ((GObject *) self, pomodoro_timer_properties[POMODORO_TIMER_STATE_PROPERTY]);
#line 1286 "timer.c"
}

gdouble
pomodoro_timer_get_state_duration (PomodoroTimer* self)
{
	gdouble result;
	gdouble _tmp0_ = 0.0;
	PomodoroTimerState* _tmp1_;
#line 50 "../src/timer.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 51 "../src/timer.vala"
	_tmp1_ = self->priv->_state;
#line 51 "../src/timer.vala"
	if (_tmp1_ != NULL) {
#line 1301 "timer.c"
		PomodoroTimerState* _tmp2_;
		gdouble _tmp3_;
		gdouble _tmp4_;
#line 51 "../src/timer.vala"
		_tmp2_ = self->priv->_state;
#line 51 "../src/timer.vala"
		_tmp3_ = pomodoro_timer_state_get_duration (_tmp2_);
#line 51 "../src/timer.vala"
		_tmp4_ = _tmp3_;
#line 51 "../src/timer.vala"
		_tmp0_ = _tmp4_;
#line 1313 "timer.c"
	} else {
#line 51 "../src/timer.vala"
		_tmp0_ = 0.0;
#line 1317 "timer.c"
	}
#line 51 "../src/timer.vala"
	result = _tmp0_;
#line 51 "../src/timer.vala"
	return result;
#line 1323 "timer.c"
}

void
pomodoro_timer_set_state_duration (PomodoroTimer* self,
                                   gdouble value)
{
	PomodoroTimerState* _tmp0_;
#line 53 "../src/timer.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/timer.vala"
	_tmp0_ = self->priv->_state;
#line 54 "../src/timer.vala"
	if (_tmp0_ != NULL) {
#line 1337 "timer.c"
		PomodoroTimerState* _tmp1_;
#line 55 "../src/timer.vala"
		_tmp1_ = self->priv->_state;
#line 55 "../src/timer.vala"
		pomodoro_timer_state_set_duration (_tmp1_, value);
#line 1343 "timer.c"
	}
}

gdouble
pomodoro_timer_get_elapsed (PomodoroTimer* self)
{
	gdouble result;
	gdouble _tmp0_ = 0.0;
	PomodoroTimerState* _tmp1_;
#line 62 "../src/timer.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 63 "../src/timer.vala"
	_tmp1_ = self->priv->_state;
#line 63 "../src/timer.vala"
	if (_tmp1_ != NULL) {
#line 1359 "timer.c"
		PomodoroTimerState* _tmp2_;
		gdouble _tmp3_;
		gdouble _tmp4_;
#line 63 "../src/timer.vala"
		_tmp2_ = self->priv->_state;
#line 63 "../src/timer.vala"
		_tmp3_ = pomodoro_timer_state_get_elapsed (_tmp2_);
#line 63 "../src/timer.vala"
		_tmp4_ = _tmp3_;
#line 63 "../src/timer.vala"
		_tmp0_ = _tmp4_;
#line 1371 "timer.c"
	} else {
#line 63 "../src/timer.vala"
		_tmp0_ = 0.0;
#line 1375 "timer.c"
	}
#line 63 "../src/timer.vala"
	result = _tmp0_;
#line 63 "../src/timer.vala"
	return result;
#line 1381 "timer.c"
}

void
pomodoro_timer_set_elapsed (PomodoroTimer* self,
                            gdouble value)
{
	PomodoroTimerState* _tmp0_;
#line 65 "../src/timer.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/timer.vala"
	_tmp0_ = self->priv->_state;
#line 66 "../src/timer.vala"
	pomodoro_timer_state_set_elapsed (_tmp0_, value);
#line 67 "../src/timer.vala"
	pomodoro_timer_update_offset (self);
#line 1397 "timer.c"
}

gdouble
pomodoro_timer_get_remaining (PomodoroTimer* self)
{
	gdouble result;
	gdouble _tmp0_ = 0.0;
	PomodoroTimerState* _tmp1_;
#line 73 "../src/timer.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 74 "../src/timer.vala"
	_tmp1_ = self->priv->_state;
#line 74 "../src/timer.vala"
	if (_tmp1_ != NULL) {
#line 1412 "timer.c"
		PomodoroTimerState* _tmp2_;
		gdouble _tmp3_;
		gdouble _tmp4_;
		PomodoroTimerState* _tmp5_;
		gdouble _tmp6_;
		gdouble _tmp7_;
#line 74 "../src/timer.vala"
		_tmp2_ = self->priv->_state;
#line 74 "../src/timer.vala"
		_tmp3_ = pomodoro_timer_state_get_duration (_tmp2_);
#line 74 "../src/timer.vala"
		_tmp4_ = _tmp3_;
#line 74 "../src/timer.vala"
		_tmp5_ = self->priv->_state;
#line 74 "../src/timer.vala"
		_tmp6_ = pomodoro_timer_state_get_elapsed (_tmp5_);
#line 74 "../src/timer.vala"
		_tmp7_ = _tmp6_;
#line 74 "../src/timer.vala"
		_tmp0_ = _tmp4_ - _tmp7_;
#line 1433 "timer.c"
	} else {
#line 74 "../src/timer.vala"
		_tmp0_ = 0.0;
#line 1437 "timer.c"
	}
#line 74 "../src/timer.vala"
	result = _tmp0_;
#line 74 "../src/timer.vala"
	return result;
#line 1443 "timer.c"
}

void
pomodoro_timer_set_remaining (PomodoroTimer* self,
                              gdouble value)
{
	PomodoroTimerState* _tmp0_;
	PomodoroTimerState* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
#line 76 "../src/timer.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/timer.vala"
	_tmp0_ = self->priv->_state;
#line 77 "../src/timer.vala"
	_tmp1_ = self->priv->_state;
#line 77 "../src/timer.vala"
	_tmp2_ = pomodoro_timer_state_get_duration (_tmp1_);
#line 77 "../src/timer.vala"
	_tmp3_ = _tmp2_;
#line 77 "../src/timer.vala"
	pomodoro_timer_state_set_elapsed (_tmp0_, _tmp3_ - value);
#line 78 "../src/timer.vala"
	pomodoro_timer_update_offset (self);
#line 1468 "timer.c"
}

gdouble
pomodoro_timer_get_offset (PomodoroTimer* self)
{
	gdouble result;
#line 84 "../src/timer.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 84 "../src/timer.vala"
	result = self->priv->_offset;
#line 84 "../src/timer.vala"
	return result;
#line 1481 "timer.c"
}

static void
pomodoro_timer_set_offset (PomodoroTimer* self,
                           gdouble value)
{
#line 85 "../src/timer.vala"
	g_return_if_fail (self != NULL);
#line 85 "../src/timer.vala"
	self->priv->_offset = value;
#line 1492 "timer.c"
}

gboolean
pomodoro_timer_get_is_paused (PomodoroTimer* self)
{
	gboolean result;
#line 90 "../src/timer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 91 "../src/timer.vala"
	result = self->priv->_is_paused;
#line 91 "../src/timer.vala"
	return result;
#line 1505 "timer.c"
}

void
pomodoro_timer_set_is_paused (PomodoroTimer* self,
                              gboolean value)
{
#line 93 "../src/timer.vala"
	g_return_if_fail (self != NULL);
#line 94 "../src/timer.vala"
	pomodoro_timer_set_is_paused_full (self, value, pomodoro_get_current_time ());
#line 1516 "timer.c"
}

gdouble
pomodoro_timer_get_timestamp (PomodoroTimer* self)
{
	gdouble result;
#line 99 "../src/timer.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 99 "../src/timer.vala"
	result = self->priv->_timestamp;
#line 99 "../src/timer.vala"
	return result;
#line 1529 "timer.c"
}

void
pomodoro_timer_set_timestamp (PomodoroTimer* self,
                              gdouble value)
{
	gdouble old_value;
#line 100 "../src/timer.vala"
	g_return_if_fail (self != NULL);
#line 100 "../src/timer.vala"
	old_value = pomodoro_timer_get_timestamp (self);
#line 100 "../src/timer.vala"
	if (old_value != value) {
#line 100 "../src/timer.vala"
		self->priv->_timestamp = value;
#line 100 "../src/timer.vala"
		g_object_notify_by_pspec ((GObject *) self, pomodoro_timer_properties[POMODORO_TIMER_TIMESTAMP_PROPERTY]);
#line 1547 "timer.c"
	}
}

gdouble
pomodoro_timer_get_score (PomodoroTimer* self)
{
	gdouble result;
#line 109 "../src/timer.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 109 "../src/timer.vala"
	result = self->priv->_score;
#line 109 "../src/timer.vala"
	return result;
#line 1561 "timer.c"
}

void
pomodoro_timer_set_score (PomodoroTimer* self,
                          gdouble value)
{
	gdouble old_value;
#line 109 "../src/timer.vala"
	g_return_if_fail (self != NULL);
#line 109 "../src/timer.vala"
	old_value = pomodoro_timer_get_score (self);
#line 109 "../src/timer.vala"
	if (old_value != value) {
#line 109 "../src/timer.vala"
		self->priv->_score = value;
#line 109 "../src/timer.vala"
		g_object_notify_by_pspec ((GObject *) self, pomodoro_timer_properties[POMODORO_TIMER_SCORE_PROPERTY]);
#line 1579 "timer.c"
	}
}

static void
pomodoro_timer_real_update (PomodoroTimer* self,
                            gdouble timestamp)
{
#line 319 "../src/timer.vala"
	pomodoro_timer_set_timestamp (self, timestamp);
#line 321 "../src/timer.vala"
	if (!self->priv->_is_paused) {
#line 323 "../src/timer.vala"
		pomodoro_timer_update_elapsed (self);
#line 325 "../src/timer.vala"
		if (!pomodoro_timer_resolve_state (self)) {
#line 326 "../src/timer.vala"
			g_object_notify ((GObject*) self, "elapsed");
#line 1597 "timer.c"
		}
	} else {
#line 330 "../src/timer.vala"
		pomodoro_timer_update_offset (self);
#line 1602 "timer.c"
	}
}

static void
_pomodoro_timer_on_state_duration_notify_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self)
{
#line 336 "../src/timer.vala"
	pomodoro_timer_on_state_duration_notify ((PomodoroTimer*) self);
#line 1613 "timer.c"
}

static void
pomodoro_timer_real_state_enter (PomodoroTimer* self,
                                 PomodoroTimerState* state)
{
#line 334 "../src/timer.vala"
	g_return_if_fail (state != NULL);
#line 336 "../src/timer.vala"
	g_signal_connect_object ((GObject*) state, "notify::duration", (GCallback) _pomodoro_timer_on_state_duration_notify_g_object_notify, self, 0);
#line 1624 "timer.c"
}

static void
pomodoro_timer_real_state_leave (PomodoroTimer* self,
                                 PomodoroTimerState* state)
{
	guint _tmp0_;
	GQuark _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
#line 339 "../src/timer.vala"
	g_return_if_fail (state != NULL);
#line 341 "../src/timer.vala"
	g_signal_parse_name ("notify::duration", G_TYPE_OBJECT, &_tmp0_, &_tmp1_, TRUE);
#line 341 "../src/timer.vala"
	g_signal_handlers_disconnect_matched ((GObject*) state, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, _tmp1_, NULL, (GCallback) _pomodoro_timer_on_state_duration_notify_g_object_notify, self);
#line 343 "../src/timer.vala"
	_tmp2_ = self->priv->_score;
#line 343 "../src/timer.vala"
	_tmp3_ = self->priv->_timestamp;
#line 343 "../src/timer.vala"
	pomodoro_timer_set_score (self, pomodoro_timer_state_calculate_score (state, _tmp2_, _tmp3_));
#line 1647 "timer.c"
}

static void
pomodoro_timer_real_state_changed (PomodoroTimer* self,
                                   PomodoroTimerState* state,
                                   PomodoroTimerState* previous_state)
{
#line 346 "../src/timer.vala"
	g_return_if_fail (state != NULL);
#line 346 "../src/timer.vala"
	g_return_if_fail (previous_state != NULL);
#line 350 "../src/timer.vala"
	pomodoro_timer_update_timeout (self);
#line 352 "../src/timer.vala"
	g_object_notify ((GObject*) self, "state");
#line 353 "../src/timer.vala"
	g_object_notify ((GObject*) self, "elapsed");
#line 1665 "timer.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 34 "../src/timer.vala"
	g_return_if_fail (n_param_values == 3);
#line 34 "../src/timer.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 34 "../src/timer.vala"
		data1 = closure->data;
#line 34 "../src/timer.vala"
		data2 = param_values->data[0].v_pointer;
#line 1690 "timer.c"
	} else {
#line 34 "../src/timer.vala"
		data1 = param_values->data[0].v_pointer;
#line 34 "../src/timer.vala"
		data2 = closure->data;
#line 1696 "timer.c"
	}
#line 34 "../src/timer.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 34 "../src/timer.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 1702 "timer.c"
}

static void
pomodoro_timer_real_destroy (PomodoroTimer* self)
{
#line 458 "../src/timer.vala"
	g_object_run_dispose ((GObject*) self);
#line 1710 "timer.c"
}

static GObject *
pomodoro_timer_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PomodoroTimer * self;
	PomodoroDisabledState* _tmp0_;
	PomodoroTimerState* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
#line 116 "../src/timer.vala"
	parent_class = G_OBJECT_CLASS (pomodoro_timer_parent_class);
#line 116 "../src/timer.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 116 "../src/timer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_TIMER, PomodoroTimer);
#line 118 "../src/timer.vala"
	_tmp0_ = pomodoro_disabled_state_new ();
#line 118 "../src/timer.vala"
	_g_object_unref0 (self->priv->_state);
#line 118 "../src/timer.vala"
	self->priv->_state = (PomodoroTimerState*) _tmp0_;
#line 119 "../src/timer.vala"
	_tmp1_ = self->priv->_state;
#line 119 "../src/timer.vala"
	_tmp2_ = pomodoro_timer_state_get_timestamp (_tmp1_);
#line 119 "../src/timer.vala"
	_tmp3_ = _tmp2_;
#line 119 "../src/timer.vala"
	pomodoro_timer_set_timestamp (self, _tmp3_);
#line 116 "../src/timer.vala"
	return obj;
#line 1747 "timer.c"
}

static void
pomodoro_timer_class_init (PomodoroTimerClass * klass,
                           gpointer klass_data)
{
#line 34 "../src/timer.vala"
	pomodoro_timer_parent_class = g_type_class_peek_parent (klass);
#line 34 "../src/timer.vala"
	g_type_class_adjust_private_offset (klass, &PomodoroTimer_private_offset);
#line 34 "../src/timer.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) pomodoro_timer_real_dispose;
#line 34 "../src/timer.vala"
	((PomodoroTimerClass *) klass)->update = pomodoro_timer_real_update;
#line 34 "../src/timer.vala"
	((PomodoroTimerClass *) klass)->state_enter = pomodoro_timer_real_state_enter;
#line 34 "../src/timer.vala"
	((PomodoroTimerClass *) klass)->state_leave = pomodoro_timer_real_state_leave;
#line 34 "../src/timer.vala"
	((PomodoroTimerClass *) klass)->state_changed = pomodoro_timer_real_state_changed;
#line 34 "../src/timer.vala"
	((PomodoroTimerClass *) klass)->destroy = pomodoro_timer_real_destroy;
#line 34 "../src/timer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_pomodoro_timer_get_property;
#line 34 "../src/timer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_pomodoro_timer_set_property;
#line 34 "../src/timer.vala"
	G_OBJECT_CLASS (klass)->constructor = pomodoro_timer_constructor;
#line 34 "../src/timer.vala"
	G_OBJECT_CLASS (klass)->finalize = pomodoro_timer_finalize;
#line 34 "../src/timer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_TIMER_STATE_PROPERTY, pomodoro_timer_properties[POMODORO_TIMER_STATE_PROPERTY] = g_param_spec_object ("state", "state", "state", POMODORO_TYPE_TIMER_STATE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 34 "../src/timer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_TIMER_STATE_DURATION_PROPERTY, pomodoro_timer_properties[POMODORO_TIMER_STATE_DURATION_PROPERTY] = g_param_spec_double ("state-duration", "state-duration", "state-duration", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 34 "../src/timer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_TIMER_ELAPSED_PROPERTY, pomodoro_timer_properties[POMODORO_TIMER_ELAPSED_PROPERTY] = g_param_spec_double ("elapsed", "elapsed", "elapsed", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 34 "../src/timer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_TIMER_REMAINING_PROPERTY, pomodoro_timer_properties[POMODORO_TIMER_REMAINING_PROPERTY] = g_param_spec_double ("remaining", "remaining", "remaining", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 34 "../src/timer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_TIMER_OFFSET_PROPERTY, pomodoro_timer_properties[POMODORO_TIMER_OFFSET_PROPERTY] = g_param_spec_double ("offset", "offset", "offset", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 34 "../src/timer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_TIMER_IS_PAUSED_PROPERTY, pomodoro_timer_properties[POMODORO_TIMER_IS_PAUSED_PROPERTY] = g_param_spec_boolean ("is-paused", "is-paused", "is-paused", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 34 "../src/timer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_TIMER_TIMESTAMP_PROPERTY, pomodoro_timer_properties[POMODORO_TIMER_TIMESTAMP_PROPERTY] = g_param_spec_double ("timestamp", "timestamp", "timestamp", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1792 "timer.c"
	/**
	         * Achieved score or number of completed sessions.
	         *
	         * It's updated on state change.
	         */
#line 34 "../src/timer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_TIMER_SCORE_PROPERTY, pomodoro_timer_properties[POMODORO_TIMER_SCORE_PROPERTY] = g_param_spec_double ("score", "score", "score", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 34 "../src/timer.vala"
	pomodoro_timer_signals[POMODORO_TIMER_UPDATE_SIGNAL] = g_signal_new ("update", POMODORO_TYPE_TIMER, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PomodoroTimerClass, update), NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
#line 34 "../src/timer.vala"
	pomodoro_timer_signals[POMODORO_TIMER_STATE_ENTER_SIGNAL] = g_signal_new ("state-enter", POMODORO_TYPE_TIMER, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PomodoroTimerClass, state_enter), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, POMODORO_TYPE_TIMER_STATE);
#line 34 "../src/timer.vala"
	pomodoro_timer_signals[POMODORO_TIMER_STATE_LEAVE_SIGNAL] = g_signal_new ("state-leave", POMODORO_TYPE_TIMER, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PomodoroTimerClass, state_leave), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, POMODORO_TYPE_TIMER_STATE);
#line 34 "../src/timer.vala"
	pomodoro_timer_signals[POMODORO_TIMER_STATE_CHANGED_SIGNAL] = g_signal_new ("state-changed", POMODORO_TYPE_TIMER, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PomodoroTimerClass, state_changed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, POMODORO_TYPE_TIMER_STATE, POMODORO_TYPE_TIMER_STATE);
#line 34 "../src/timer.vala"
	pomodoro_timer_signals[POMODORO_TIMER_DESTROY_SIGNAL] = g_signal_new ("destroy", POMODORO_TYPE_TIMER, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PomodoroTimerClass, destroy), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1810 "timer.c"
}

static void
pomodoro_timer_instance_init (PomodoroTimer * self,
                              gpointer klass)
{
#line 34 "../src/timer.vala"
	self->priv = pomodoro_timer_get_instance_private (self);
#line 108 "../src/timer.vala"
	self->priv->_score = 0.0;
#line 112 "../src/timer.vala"
	self->priv->timeout_source = (guint) 0;
#line 1823 "timer.c"
}

static void
pomodoro_timer_finalize (GObject * obj)
{
	PomodoroTimer * self;
#line 34 "../src/timer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_TIMER, PomodoroTimer);
#line 113 "../src/timer.vala"
	_g_object_unref0 (self->priv->_state);
#line 34 "../src/timer.vala"
	G_OBJECT_CLASS (pomodoro_timer_parent_class)->finalize (obj);
#line 1836 "timer.c"
}

/**
     * Pomodoro.Timer class.
     *
     * A class for a countdown timer. Timer works in an atomic manner, it acknowlegdes passage
     * of time after calling update() method.
     */
static GType
pomodoro_timer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PomodoroTimerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_timer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroTimer), 0, (GInstanceInitFunc) pomodoro_timer_instance_init, NULL };
	GType pomodoro_timer_type_id;
	pomodoro_timer_type_id = g_type_register_static (G_TYPE_OBJECT, "PomodoroTimer", &g_define_type_info, 0);
	PomodoroTimer_private_offset = g_type_add_instance_private (pomodoro_timer_type_id, sizeof (PomodoroTimerPrivate));
	return pomodoro_timer_type_id;
}

GType
pomodoro_timer_get_type (void)
{
	static volatile gsize pomodoro_timer_type_id__once = 0;
	if (g_once_init_enter (&pomodoro_timer_type_id__once)) {
		GType pomodoro_timer_type_id;
		pomodoro_timer_type_id = pomodoro_timer_get_type_once ();
		g_once_init_leave (&pomodoro_timer_type_id__once, pomodoro_timer_type_id);
	}
	return pomodoro_timer_type_id__once;
}

static void
_vala_pomodoro_timer_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	PomodoroTimer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_TIMER, PomodoroTimer);
#line 34 "../src/timer.vala"
	switch (property_id) {
#line 34 "../src/timer.vala"
		case POMODORO_TIMER_STATE_PROPERTY:
#line 34 "../src/timer.vala"
		g_value_set_object (value, pomodoro_timer_get_state (self));
#line 34 "../src/timer.vala"
		break;
#line 34 "../src/timer.vala"
		case POMODORO_TIMER_STATE_DURATION_PROPERTY:
#line 34 "../src/timer.vala"
		g_value_set_double (value, pomodoro_timer_get_state_duration (self));
#line 34 "../src/timer.vala"
		break;
#line 34 "../src/timer.vala"
		case POMODORO_TIMER_ELAPSED_PROPERTY:
#line 34 "../src/timer.vala"
		g_value_set_double (value, pomodoro_timer_get_elapsed (self));
#line 34 "../src/timer.vala"
		break;
#line 34 "../src/timer.vala"
		case POMODORO_TIMER_REMAINING_PROPERTY:
#line 34 "../src/timer.vala"
		g_value_set_double (value, pomodoro_timer_get_remaining (self));
#line 34 "../src/timer.vala"
		break;
#line 34 "../src/timer.vala"
		case POMODORO_TIMER_OFFSET_PROPERTY:
#line 34 "../src/timer.vala"
		g_value_set_double (value, pomodoro_timer_get_offset (self));
#line 34 "../src/timer.vala"
		break;
#line 34 "../src/timer.vala"
		case POMODORO_TIMER_IS_PAUSED_PROPERTY:
#line 34 "../src/timer.vala"
		g_value_set_boolean (value, pomodoro_timer_get_is_paused (self));
#line 34 "../src/timer.vala"
		break;
#line 34 "../src/timer.vala"
		case POMODORO_TIMER_TIMESTAMP_PROPERTY:
#line 34 "../src/timer.vala"
		g_value_set_double (value, pomodoro_timer_get_timestamp (self));
#line 34 "../src/timer.vala"
		break;
#line 34 "../src/timer.vala"
		case POMODORO_TIMER_SCORE_PROPERTY:
#line 34 "../src/timer.vala"
		g_value_set_double (value, pomodoro_timer_get_score (self));
#line 34 "../src/timer.vala"
		break;
#line 1925 "timer.c"
		default:
#line 34 "../src/timer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 34 "../src/timer.vala"
		break;
#line 1931 "timer.c"
	}
}

static void
_vala_pomodoro_timer_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	PomodoroTimer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_TIMER, PomodoroTimer);
#line 34 "../src/timer.vala"
	switch (property_id) {
#line 34 "../src/timer.vala"
		case POMODORO_TIMER_STATE_PROPERTY:
#line 34 "../src/timer.vala"
		pomodoro_timer_set_state (self, g_value_get_object (value));
#line 34 "../src/timer.vala"
		break;
#line 34 "../src/timer.vala"
		case POMODORO_TIMER_STATE_DURATION_PROPERTY:
#line 34 "../src/timer.vala"
		pomodoro_timer_set_state_duration (self, g_value_get_double (value));
#line 34 "../src/timer.vala"
		break;
#line 34 "../src/timer.vala"
		case POMODORO_TIMER_ELAPSED_PROPERTY:
#line 34 "../src/timer.vala"
		pomodoro_timer_set_elapsed (self, g_value_get_double (value));
#line 34 "../src/timer.vala"
		break;
#line 34 "../src/timer.vala"
		case POMODORO_TIMER_REMAINING_PROPERTY:
#line 34 "../src/timer.vala"
		pomodoro_timer_set_remaining (self, g_value_get_double (value));
#line 34 "../src/timer.vala"
		break;
#line 34 "../src/timer.vala"
		case POMODORO_TIMER_OFFSET_PROPERTY:
#line 34 "../src/timer.vala"
		pomodoro_timer_set_offset (self, g_value_get_double (value));
#line 34 "../src/timer.vala"
		break;
#line 34 "../src/timer.vala"
		case POMODORO_TIMER_IS_PAUSED_PROPERTY:
#line 34 "../src/timer.vala"
		pomodoro_timer_set_is_paused (self, g_value_get_boolean (value));
#line 34 "../src/timer.vala"
		break;
#line 34 "../src/timer.vala"
		case POMODORO_TIMER_TIMESTAMP_PROPERTY:
#line 34 "../src/timer.vala"
		pomodoro_timer_set_timestamp (self, g_value_get_double (value));
#line 34 "../src/timer.vala"
		break;
#line 34 "../src/timer.vala"
		case POMODORO_TIMER_SCORE_PROPERTY:
#line 34 "../src/timer.vala"
		pomodoro_timer_set_score (self, g_value_get_double (value));
#line 34 "../src/timer.vala"
		break;
#line 1993 "timer.c"
		default:
#line 34 "../src/timer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 34 "../src/timer.vala"
		break;
#line 1999 "timer.c"
	}
}

